#include "dialogscript.h"
#include "ui_dialogscript.h"
#include <QDebug>
#include <QAbstractButton>
#include <QFile>
#include <QDir>
#include <QMessageBox>
DialogScript::DialogScript(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogScript)
{
    ui->setupUi(this);
}

DialogScript::~DialogScript()
{
    delete ui;
}

 void DialogScript::setcomboItems(QStringList list)
 {
     for(int i=0;i<list.count();i++){
         QString line=list.at(i);
         QString txt=line.section(",",0,0);
          QString data=line.section(",",1);
         ui->comboBoxSura->addItem(txt,data);
     }
 }

void DialogScript::setUrlName(QString url)
     {
      ui->lineEdit->setText(url);
     }

void DialogScript::setPathCostum(QString arg)
{
    pathCostum=arg;
}

void DialogScript::on_comboBoxSura_currentIndexChanged(int index)
{
    QString txt=ui->comboBoxSura->itemData(index).toString();
    int max=txt.section(",",1,1).toInt();
   ui->spinBoxTo->setMaximum(max);
   ui->spinBoxFrom->setMaximum(max);
      ui->spinBoxFrom->setValue(1);
      ui->spinBoxTo->setValue(max);
}

void DialogScript::on_spinBoxFrom_valueChanged(int arg1)
{
       ui->spinBoxTo->setMinimum(arg1);
}

void DialogScript::on_buttonBox_clicked(QAbstractButton *button)
{
    if(ui->buttonBox->standardButton(button)==QDialogButtonBox::Apply){
      createScript();
    }else if(ui->buttonBox->standardButton(button)==QDialogButtonBox::Ok){
        createScript();
        this->accept();
    }

}

void DialogScript::createScript()
{
   int surat=ui->comboBoxSura->currentIndex()+1;
    QString url=ui->lineEdit->text();
    QString reciter = url.section('/', -1);
     QString sura="000"+QString::number(surat);

    QFile fileReciter(QDir::homePath()+"/"+reciter+"_"+QString::number(surat));
    if (!fileReciter.open(QFile::WriteOnly)){
          return ;
      }
    QTextStream out(&fileReciter);
    out<<"#!/bin/sh \n";
    if(ui->checkBoxNoExists->isChecked()){

        for(int i=1;i<ui->spinBoxTo->maximum()+1;i++)
        {
           QString aya="000"+QString::number(i);
           QString  soundName=sura.right(3)+aya.right(3) ;
           if(getFileExists("/"+soundName+".mp3")==false)
           out<< "wget -c  "+url+"/"+soundName+".mp3 \n";
        }
    }else{
        for(int i=ui->spinBoxFrom->value();i<ui->spinBoxTo->value()+1;i++)
        {

           QString aya="000"+QString::number(i);
           QString  soundName=sura.right(3)+aya.right(3) ;

           out<< "wget -c  "+url+"/"+soundName+".mp3 \n";
        }
    }
    QMessageBox::information(this,"","package genirated in \n "+
                             QDir::homePath()+"/"+reciter+"_"+QString::number(surat));

}

bool DialogScript::getFileExists(QString path)
{

    QDir appDir(qApp->applicationDirPath());

    appDir.cdUp();
   QString appPath=  appDir.absolutePath()+"/share/elforkane";
    if(QFile::exists(pathCostum+path)){
     //البحث عن الاية حسب ما ادخله المستخدم
     qDebug()<<pathCostum+path;
        return true;
   }else if(QFile::exists(appPath+"/"+pathCostum+path)==true){
       //usr/shar/elforkane/audio/recetername----البحث عن الاية في دليل البرنامج
   qDebug()<<"exist in apppath"<<appPath+"/"+pathCostum+path;
        return true;
   }else if(QFile::exists(QDir::homePath()+"/.elforkane/"+pathCostum+path)==true){
       //home/user/.elforkane/audio/recetername----البحث عن الاية في دليل المستخدم
 qDebug()<<"exist in home : "<<QDir::homePath()+"/.elforkane/"+pathCostum+path;
        return true;
   }
    return false;
}
